# -*- coding: utf-8 -*- #
# Copyright 2014 Google LLC. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
"""The gcloud firestore group."""

from __future__ import absolute_import
from __future__ import division
from __future__ import unicode_literals

from googlecloudsdk.calliope import base


@base.DefaultUniverseOnly
@base.ReleaseTracks(
    base.ReleaseTrack.GA, base.ReleaseTrack.BETA, base.ReleaseTrack.ALPHA
)
class Firestore(base.Group):
  """Manage your Cloud Firestore resources.

  export -- Export data to Google Cloud Storage

  import -- Import data from Google Cloud Storage

  bulk-delete -- Bulk delete documents from Cloud Firestore

  indexes -- Manage your Cloud Firestore indexes

  operations -- Manage Long Running Operations for Cloud Firestore
  """

  category = base.DATABASES_CATEGORY

  def Filter(self, context, args):
    # TODO(b/190534490):  Determine if command group works with project number
    base.RequireProjectID(args)
    del context, args
