# coding: utf-8
"""
    Kubernetes

    No description provided (generated by Swagger Codegen
    https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: v1.14.4

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from pprint import pformat
from six import iteritems
import re


class V1AWSElasticBlockStoreVolumeSource(object):
  """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
  """
    Attributes:
      swagger_types (dict): The key is attribute name and the value is attribute
        type.
      attribute_map (dict): The key is attribute name and the value is json key
        in definition.
  """
  swagger_types = {
      'fs_type': 'str',
      'partition': 'int',
      'read_only': 'bool',
      'volume_id': 'str'
  }

  attribute_map = {
      'fs_type': 'fsType',
      'partition': 'partition',
      'read_only': 'readOnly',
      'volume_id': 'volumeID'
  }

  def __init__(self,
               fs_type=None,
               partition=None,
               read_only=None,
               volume_id=None):
    """
        V1AWSElasticBlockStoreVolumeSource - a model defined in Swagger
        """

    self._fs_type = None
    self._partition = None
    self._read_only = None
    self._volume_id = None
    self.discriminator = None

    if fs_type is not None:
      self.fs_type = fs_type
    if partition is not None:
      self.partition = partition
    if read_only is not None:
      self.read_only = read_only
    self.volume_id = volume_id

  @property
  def fs_type(self):
    """
        Gets the fs_type of this V1AWSElasticBlockStoreVolumeSource.
        Filesystem type of the volume that you want to mount. Tip: Ensure that
        the filesystem type is supported by the host operating system. Examples:
        \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if
        unspecified. More info:
        https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

        :return: The fs_type of this V1AWSElasticBlockStoreVolumeSource.
        :rtype: str
        """
    return self._fs_type

  @fs_type.setter
  def fs_type(self, fs_type):
    """
        Sets the fs_type of this V1AWSElasticBlockStoreVolumeSource.
        Filesystem type of the volume that you want to mount. Tip: Ensure that
        the filesystem type is supported by the host operating system. Examples:
        \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if
        unspecified. More info:
        https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

        :param fs_type: The fs_type of this V1AWSElasticBlockStoreVolumeSource.
        :type: str
        """

    self._fs_type = fs_type

  @property
  def partition(self):
    """
        Gets the partition of this V1AWSElasticBlockStoreVolumeSource.
        The partition in the volume that you want to mount. If omitted, the
        default is to mount by volume name. Examples: For volume /dev/sda1, you
        specify the partition as \"1\". Similarly, the volume partition for
        /dev/sda is \"0\" (or you can leave the property empty).

        :return: The partition of this V1AWSElasticBlockStoreVolumeSource.
        :rtype: int
        """
    return self._partition

  @partition.setter
  def partition(self, partition):
    """
        Sets the partition of this V1AWSElasticBlockStoreVolumeSource.
        The partition in the volume that you want to mount. If omitted, the
        default is to mount by volume name. Examples: For volume /dev/sda1, you
        specify the partition as \"1\". Similarly, the volume partition for
        /dev/sda is \"0\" (or you can leave the property empty).

        :param partition: The partition of this
        V1AWSElasticBlockStoreVolumeSource.
        :type: int
        """

    self._partition = partition

  @property
  def read_only(self):
    """
        Gets the read_only of this V1AWSElasticBlockStoreVolumeSource.
        Specify \"true\" to force and set the ReadOnly property in VolumeMounts
        to \"true\". If omitted, the default is \"false\". More info:
        https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

        :return: The read_only of this V1AWSElasticBlockStoreVolumeSource.
        :rtype: bool
        """
    return self._read_only

  @read_only.setter
  def read_only(self, read_only):
    """
        Sets the read_only of this V1AWSElasticBlockStoreVolumeSource.
        Specify \"true\" to force and set the ReadOnly property in VolumeMounts
        to \"true\". If omitted, the default is \"false\". More info:
        https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

        :param read_only: The read_only of this
        V1AWSElasticBlockStoreVolumeSource.
        :type: bool
        """

    self._read_only = read_only

  @property
  def volume_id(self):
    """
        Gets the volume_id of this V1AWSElasticBlockStoreVolumeSource.
        Unique ID of the persistent disk resource in AWS (Amazon EBS volume).
        More info:
        https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

        :return: The volume_id of this V1AWSElasticBlockStoreVolumeSource.
        :rtype: str
        """
    return self._volume_id

  @volume_id.setter
  def volume_id(self, volume_id):
    """
        Sets the volume_id of this V1AWSElasticBlockStoreVolumeSource.
        Unique ID of the persistent disk resource in AWS (Amazon EBS volume).
        More info:
        https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

        :param volume_id: The volume_id of this
        V1AWSElasticBlockStoreVolumeSource.
        :type: str
        """
    if volume_id is None:
      raise ValueError('Invalid value for `volume_id`, must not be `None`')

    self._volume_id = volume_id

  def to_dict(self):
    """
        Returns the model properties as a dict
        """
    result = {}

    for attr, _ in iteritems(self.swagger_types):
      value = getattr(self, attr)
      if isinstance(value, list):
        result[attr] = list(
            map(lambda x: x.to_dict() if hasattr(x, 'to_dict') else x, value))
      elif hasattr(value, 'to_dict'):
        result[attr] = value.to_dict()
      elif isinstance(value, dict):
        result[attr] = dict(
            map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], 'to_dict') else item, value.items()))
      else:
        result[attr] = value

    return result

  def to_str(self):
    """
        Returns the string representation of the model
        """
    return pformat(self.to_dict())

  def __repr__(self):
    """
        For `print` and `pprint`
        """
    return self.to_str()

  def __eq__(self, other):
    """
        Returns true if both objects are equal
        """
    if not isinstance(other, V1AWSElasticBlockStoreVolumeSource):
      return False

    return self.__dict__ == other.__dict__

  def __ne__(self, other):
    """
        Returns true if both objects are not equal
        """
    return not self == other
