# coding: utf-8
"""
    Kubernetes

    No description provided (generated by Swagger Codegen
    https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: v1.14.4

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from pprint import pformat
from six import iteritems
import re


class V1CinderPersistentVolumeSource(object):
  """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
  """
    Attributes:
      swagger_types (dict): The key is attribute name and the value is attribute
        type.
      attribute_map (dict): The key is attribute name and the value is json key
        in definition.
  """
  swagger_types = {
      'fs_type': 'str',
      'read_only': 'bool',
      'secret_ref': 'V1SecretReference',
      'volume_id': 'str'
  }

  attribute_map = {
      'fs_type': 'fsType',
      'read_only': 'readOnly',
      'secret_ref': 'secretRef',
      'volume_id': 'volumeID'
  }

  def __init__(self,
               fs_type=None,
               read_only=None,
               secret_ref=None,
               volume_id=None):
    """
        V1CinderPersistentVolumeSource - a model defined in Swagger
        """

    self._fs_type = None
    self._read_only = None
    self._secret_ref = None
    self._volume_id = None
    self.discriminator = None

    if fs_type is not None:
      self.fs_type = fs_type
    if read_only is not None:
      self.read_only = read_only
    if secret_ref is not None:
      self.secret_ref = secret_ref
    self.volume_id = volume_id

  @property
  def fs_type(self):
    """
        Gets the fs_type of this V1CinderPersistentVolumeSource.
        Filesystem type to mount. Must be a filesystem type supported by the
        host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly
        inferred to be \"ext4\" if unspecified. More info:
        https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md

        :return: The fs_type of this V1CinderPersistentVolumeSource.
        :rtype: str
        """
    return self._fs_type

  @fs_type.setter
  def fs_type(self, fs_type):
    """
        Sets the fs_type of this V1CinderPersistentVolumeSource.
        Filesystem type to mount. Must be a filesystem type supported by the
        host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly
        inferred to be \"ext4\" if unspecified. More info:
        https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md

        :param fs_type: The fs_type of this V1CinderPersistentVolumeSource.
        :type: str
        """

    self._fs_type = fs_type

  @property
  def read_only(self):
    """
        Gets the read_only of this V1CinderPersistentVolumeSource.
        Optional: Defaults to false (read/write). ReadOnly here will force the
        ReadOnly setting in VolumeMounts. More info:
        https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md

        :return: The read_only of this V1CinderPersistentVolumeSource.
        :rtype: bool
        """
    return self._read_only

  @read_only.setter
  def read_only(self, read_only):
    """
        Sets the read_only of this V1CinderPersistentVolumeSource.
        Optional: Defaults to false (read/write). ReadOnly here will force the
        ReadOnly setting in VolumeMounts. More info:
        https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md

        :param read_only: The read_only of this V1CinderPersistentVolumeSource.
        :type: bool
        """

    self._read_only = read_only

  @property
  def secret_ref(self):
    """
        Gets the secret_ref of this V1CinderPersistentVolumeSource.
        Optional: points to a secret object containing parameters used to
        connect to OpenStack.

        :return: The secret_ref of this V1CinderPersistentVolumeSource.
        :rtype: V1SecretReference
        """
    return self._secret_ref

  @secret_ref.setter
  def secret_ref(self, secret_ref):
    """
        Sets the secret_ref of this V1CinderPersistentVolumeSource.
        Optional: points to a secret object containing parameters used to
        connect to OpenStack.

        :param secret_ref: The secret_ref of this
        V1CinderPersistentVolumeSource.
        :type: V1SecretReference
        """

    self._secret_ref = secret_ref

  @property
  def volume_id(self):
    """
        Gets the volume_id of this V1CinderPersistentVolumeSource.
        volume id used to identify the volume in cinder More info:
        https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md

        :return: The volume_id of this V1CinderPersistentVolumeSource.
        :rtype: str
        """
    return self._volume_id

  @volume_id.setter
  def volume_id(self, volume_id):
    """
        Sets the volume_id of this V1CinderPersistentVolumeSource.
        volume id used to identify the volume in cinder More info:
        https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md

        :param volume_id: The volume_id of this V1CinderPersistentVolumeSource.
        :type: str
        """
    if volume_id is None:
      raise ValueError('Invalid value for `volume_id`, must not be `None`')

    self._volume_id = volume_id

  def to_dict(self):
    """
        Returns the model properties as a dict
        """
    result = {}

    for attr, _ in iteritems(self.swagger_types):
      value = getattr(self, attr)
      if isinstance(value, list):
        result[attr] = list(
            map(lambda x: x.to_dict() if hasattr(x, 'to_dict') else x, value))
      elif hasattr(value, 'to_dict'):
        result[attr] = value.to_dict()
      elif isinstance(value, dict):
        result[attr] = dict(
            map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], 'to_dict') else item, value.items()))
      else:
        result[attr] = value

    return result

  def to_str(self):
    """
        Returns the string representation of the model
        """
    return pformat(self.to_dict())

  def __repr__(self):
    """
        For `print` and `pprint`
        """
    return self.to_str()

  def __eq__(self, other):
    """
        Returns true if both objects are equal
        """
    if not isinstance(other, V1CinderPersistentVolumeSource):
      return False

    return self.__dict__ == other.__dict__

  def __ne__(self, other):
    """
        Returns true if both objects are not equal
        """
    return not self == other
